## New Super Mario Bros. 2 - Special Edition (Europe) & Gold Edition (USA)

### Cheats Overview
**************************************************
**<details><summary>` CLICK TO SHOW/HIDE AVAILABLE CHEATS FOR THIS GAME `</summary>**
<p>

> Character Modifier
> ----------------------------------
  - `Play as Mario`
  - `Play as Luigi`
    - *Even when game not beaten.*
  - `No Hat`
    - *Doesn't require max (1110) lives.*
  - `Half Sized Mario/Luigi`
    - *When in level.*
    - *Does not affect hitbox.*
    - *Turn off when Mega Mario/Luigi Powerup wears off in order to unfreeze game.*
  - `Double Sized Mario/Luigi`
    - *When in level.*
    - *Does not affect hitbox.*
    - *Turn off when Mega Mario/Luigi Powerup wears off in order to unfreeze game.*
  - `Invisible Mario/Luigi`
    - *When in level.*
    - *Does not affect hitbox.*
    - *Turn off when Mega Mario/Luigi Powerup wears off in order to unfreeze game.*
> Character Powerups
> ----------------------------------
  - `(L+Down) Small Mario/Luigi`
  - `(L+Left) Big Mario/Luigi`
  - `(L+Right) Fire Mario/Luigi`
  - `(L+Up) Tanooki Mario/Luigi`
  - `(R+Down) Mini Mario/Luigi`
  - `(R+Left) Mega Mario/Luigi`
    - *Only works in intended (sub)levels:*
      - *1-2 (Underground only)*
      - *5-6*
      - *M-3*
    - *Not (yet) optimized to work in Coin Rush levels that have a Mega Mushroom powerup.*
  - `(R+Right) Gold Mario/Luigi`
  - `(R+Up) White Tanooki Mario/Luigi`
> Character Abilities
> ----------------------------------
  - `Always White Tanooki Suit`
  - `Always Full Tanooki Pwing Gauge`
  - `Always Star Power`
  - `Always Gold Block Head`
    - *Start each level as Gold Block Head.*
    - *Has unlimited coins.*
    - *Getting hit loses it temporarily.*
  - `Always Shoot Fireballs`
    - *In effect when playing a level.*
    - *In order to restore game default, disable this cheat code when not in a level.*
  - `Always Shoot Gold Fireballs`
    - *In effect when playing a level.*
    - *In order to restore game default, disable this cheat code when not in a level.*
  - `Rapid Fireballs`
    - *In effect when playing a level.*
    - *In order to restore game default, disable this cheat code when not in a level.*
    - *Works for Fire and Gold Mario/Luigi and in combination with above Fireball codes.*
  - `Moon Jump`
    - *Makes Mario/Luigi jump higher.*
    - *Code optimized for use with Luma~Rosalina's cheat engine.*
    - *Read cheat code note for use with CTRPluginFramework.*
  - `(B) Infinite Jump`
    - *Allows Mario/Luigi to infinitely jump multiple times in mid-air.*
    - *Hold button to jump as high as desired.*
> Unlocks/Sets/Resets
> ----------------------------------
  - `Max Lives (Three Crowns)`
  - `5 Lives`
  - `Infinite Time`
    - *Persistent code, even when turning off cheat.*
  - `Flying Gold Coin Block (At Level Start)`
  - `3 Star/Moon Coins Collected (Per Level)`
    - *Per level code. Registers after finishing level.*
  - `All Star Coins (All Levels)`
  - `Reset Star Coins (All Levels)`
  - `All Moon Coins (All Star Levels)`
  - `Reset Moon Coins (All Star Levels)`
  - `219 Star/Moon Coins (Counter)`
  - `000 Star/Moon Coins (Counter)`
  - `Enable Gold Leaf Block (All Levels)`
  - `Disable Gold Leaf Block (All Levels)`
  - `(L+R+Left+A) Unlock All (5 Star Save)`
    - *For currently opened save file:*
      - *Max lives (1110), Three Crowns & No Hat Mario/Luigi.*
      - *All levels opened & cleared (including Rainbow Levels & Toad Houses).*
      - *All Star Coins in Worlds 1-6 and Mushroom/Flower Worlds collected.*
      - *All Moon Coins in Star World collected.*
      - *All paths opened (the ones that cost Star/Moon coins + all hidden exits).*
    - *Additionally:*
      - *Unlocks all Coin Rush levels.*
      - *Sets Star/Moon counter to zero since all star pathways are opened.*
      - *Disables Gold Leaf Blocks in all levels to make sure saving game results in a Shiny Star save.*
      - *Enables a Flying Gold Coin Block.*
      - *Puts a Star in Item Box.*
    - *Results in a 5 Shiny Star save game when saved.*
  - `9999 Coin Score (All Levels)`
  - `0000 Coin Score (All Levels)`
  - `9999999 Total Coins (Counter)`
  - `1000000 Total Coins (Counter)`
  - `0000000 Total Coins (Counter)`
> Ease Of Use
> ----------------------------------
  - `No Game Over`
  - `Able To Leave Unfinished Levels`
    - *Press Down at pause screen to highlight and enable level exit.*
> Teleport
> ----------------------------------
  - `Straight To Bowser`
  - `Straight To End Credits`
> Quick Presets
> ----------------------------------
  - `Easy Peasy Level Easy`
    - *Star Power*
    - *(B) Infinite Jump*
    - *Infinite Time*
  - `Coin Rusher`
    - *Star Power*
    - *Gold Block Head*
    - *Rapid Gold Fireballs*
    - *Infinite Time*

</p>
</details>

**************************************************

### General Notes:
  - In order for enabled cheat codes to take effect, depending on the code enabled, <br />**some codes require you to:**
    - **Use a button combination.**
      - *These codes are marked with a * and list the button combination to be used between (parentheses).*
    - **Trigger a screen transition.** Accomplishable by, for example:
      - *Switching between Worlds on World Map (if more then one World opened).*
      - *Entering and exiting a level.*
	- *Some codes require this because of checks used in the code.*
	- *For exiting a level, any of the following options are valid:*
	  - *Die in level.*
	  - *Pause and return to map.*
	  - *Finish a level.*
  - In order to be successfully disabled, <br />**the following cheat codes need to be disabled when not in a level:**
	  - *Always Shoot Fireballs*
	  - *Always Shoot Gold Fireballs*
	  - *Rapid Fireballs*
	  - *Infinite Time*
	  - *All Quick Presets using any of the above cheat codes.*
  - All codes can be used in all levels (including Bowser Castle).

### Installation
- [Download the latest version of the NSMB2-SE+GE cheat files](https://github.com/KimDebroye/N3DS-Cheat-Codes/releases/tag/v2.2.1).
- Running **Custom Firmware Luma3DS 9.1 or higher**:
  - Insert the SD/MicroSD card into your computer/phone.
    - *You can also use FTP if you are familiar with that.*
  - Create a folder named `cheats` on the root of your SD/MicroSD card (if it doesn't already exist).
  - Place/Overwrite the .txt file(s) containing the cheats for your game region in this folder.
    - For **New Super Mario Bros 2 - Special Edition (Europe)**:
      - *SD/MicroSD card root*/`cheats`/**0004000000137F00.txt**
    - For **New Super Mario Bros 2 - Gold Edition (USA)**:
      - *SD/MicroSD card root*/`cheats`/**0004000000137E00.txt**
  - When transfered, eject/unmount the SD/MicroSD card from your computer/phone.
    - *Or disconnect the FTP connection.*
  - Launch the game and pull up the Rosalina menu (`L+Down+Select`).
  - Select the menu option "Cheats".
  - Select the cheats you want to activate by pressing the A button.
    - Certain cheats need additional key combinations when in game. These cheats are marked with a * and also mention the key combinations to use in order to activate the cheat at any given time when in game.
  - Exit out of the Rosalina menu by pressing the B button until the game is back in focus.
- Happy cheating!

### Cheat Compatibility
- Compatible with
  - Old & New 2DS/3DS XL
  - Custom Firmware
    - Luma3DS 10.0.1
    - Luma3DS 9.1 (with/without CTRPF plugin loader).

### Bugs/Issues/Feedback
- No notable crashes (as of Stable Release Version 2.1).
  - **I do however strongly recommend not to enable all cheat codes at once and occasionally disable any cheat codes that aren't of use anymore (f.e. unlock/set/reset codes, ...).**
- Should you have feedback, feel free to drop a comment in [the GBAtemp release thread](https://gbatemp.net/threads/release-new-super-mario-bros-2-gold-special-edition-cheat-codes.550034/).

### Credits, Software/Tools Used & Technical Notes
- [CTRPluginFramework (by Nanquitas)](https://github.com/Nanquitas/CTRPluginFramework-BlankTemplate)
  - *Used for searching addresses/values and creating RAM dumps.*
- [Gateway RAM Tools](https://www.maxconsole.com/threads/tool-gateway-ram-tools.40776/)
  - *Used for converting RAM dumps to raw RAM dumps.*
- [TempAR](https://raing3.gshi.org/files/psp/tools/pointer_searcher.zip)
  - *Used to find pointer addresses in raw RAM dumps.*
- [HxD: Freeware Hex Editor](https://mh-nexus.de/en/hxd/)
  - *Used for manually searching addresses/values by comparing and reading raw RAM dumps.*
- [NSMB2 Save Editor](https://gbatemp.net/threads/release-new-super-mario-bros-2-save-editor.396734/)
  - *Used for unlocking a fully completed save in order to compare RAM dumps. Thanks a bunch!*
- I searched/created (almost) all codes myself using the above software/tools and RAM Dump comparisons (no ASM).
- Codes I reused/edited/ported from other cheat contributors
@ [Max-Cheats](https://www.max-cheats.com/view.php?ItemID=206) / [GameHacking](https://gamehacking.org/game/115234) / [CTRPF Cheat Code Db](https://github.com/JourneyOver/CTRPF-AR-CHEAT-CODES/blob/master/Cheats/New%20Super%20Mario%20Bros.%202%20(Gold%20Edition)%20(USA)/0004000000137E00.txt):
  - Instant Powerup Change codes
  	- Merged and edited existing codes.
  - Always Shoot Fireballs
  	- Ported & optimized the NSMB2 Non Gold/Special Edition (USA) cheat code to both regions (SE+GE).
  - Always Shoot Gold Fireballs
  	- Ported & optimized the NSMB2 Non Gold/Special Edition (USA) cheat code to both regions (SE+GE).
  - Rapid Fireballs
  	- Ported & optimized the NSMB2 Gold Edition (USA) cheat code to NSMB2 Special Edition (Europe).
  - Able To Leave Unfinished Levels
  	- Ported the NSMB2 Non Gold/Special Edition (USA) cheat code to both regions (SE+GE).
- I added my notes to this repository for those interested in reading about [my findings and thought process](https://github.com/KimDebroye/N3DS-Cheat-Codes/blob/master/New%20Super%20Mario%20Bros.%202%20-%20Special%20%26%20Gold%20Edition/_Findings%20%26%20Thoughts/(NSMB2%20-%20SE%2BGE)%20Findings%20%26%20Thoughts.txt). It's not very well structured though (I didn't intend it for public reading, was fine for me though to work with) and contains a few Dutch language strings, which can of course easily be translated using Google Translate for example in case needed.

### Personal Notes
I did this out of pure fun and interest to find out about how a cheating process works, not necessarily to play a game.
Learned quite a lot in the process.
It has been a fun ride finding and creating cheat codes for this game.
I sincerely hope you all like toying with the game using the cheats provided
and that it may reflect a bit of the joy I had tinkering with them.
